WoMax Documentation

# t_OMax_build Struct Reference
[Max5 Externals, Data Sequence structure]

OMax.build external. More...

Collaboration diagram for t_OMax_build:
[legend]

List of all members.

## Public Attributes
t_object | ob
| Pointer to the object itself.
t_symbol * | oname
| Pointer to source FO name.
t_symbol * | odataname
| Pointer to source Data Sequence name.
O_data * | odata
| Pointer to source Data Sequence structure.
bool | odatabound
| Source binding flag.
t_symbol * | idataname
| Pointer to new Data Sequence name.
O_data * | idata
| Pointer to new Data Sequence structure.
bool | idatabound
| New binding flag.
O_DataType | datatype
| Type of data.
long | date
| Current date.
t_atom * | addout
| Array for the output.
void * | out_state
| Outlet 0 (leftmost): state numbers.
void * | out_added
| Outlet 1: Sequence size.
void * | out_date
| Outlet 2: Ending date.
## Standard Max5 methodes
void * | OMax_build_new (t_symbol *s, long argc, t_atom *argv)
| Object instantiation.
void | OMax_build_free (t_OMax_build *x)
| Object destruction.
void | OMax_build_assist (t_OMax_build *x, void *b, long io, long index, char *s)
| Inlet/Outlet contextual information when patching in Max5.
## Internal routines
t_symbol * | OMax_build_dataname (t_symbol *name)
| Return Data Sequence name from FO name.
bool | OMax_build_bind (t_OMax_build *x)
| Bind the builder with both Data Sequences.
## Input/Output routines
void | OMax_build_bang (t_OMax_build *x)
| Output current ending date & size.
void | OMax_build_add (t_OMax_build *x, long statein)
| Add a state from the source Data Sequence to the new Data Sequence.

## Detailed Description

OMax.build external.

This external object handles the construction of a Data Sequence based on the states of another Data Sequence (OMax.data objects) in Max5

Definition at line 30 of file OMax.build.c.

## Member Function Documentation

void OMax_build_add | ( | t_OMax_build * | x,
|  | long | statein |
| ) |  |  |

Add a state from the source Data Sequence to the new Data Sequence.

Remarks:
  Input message in Max5: `add` followed by a state number (`int`)

Use the current date to reference the state in the new Data Sequence

Use duration to compute the new ending date

Output the new ending date

Output the current size

Output the pair: stated number in the source Data Sequence & state number in the new Data Sequence

Definition at line 271 of file OMax.build.c.

Here is the call graph for this function:

void OMax_build_bang | ( | t_OMax_build * | x | ) |

Output current ending date & size.

Remarks:
  Input message in Max5: `bang`

Definition at line 250 of file OMax.build.c.

Here is the call graph for this function:

bool OMax_build_bind | ( | t_OMax_build * | x | ) |

Bind the builder with both Data Sequences.

Remarks:
  Do this binding only once

Check if first name points to an existing OMax.data object. If so, binds t_OMax_build::odata with the Data Sequence structure (t_OMax_data::data member).

Check if second name points to an existing OMax.data object. If so, binds t_OMax_build::idata with the Data Sequence structure (t_OMax_data::data member).

Remarks:
  This binding do not check that the two Data Sequences hold the same type of data

Definition at line 203 of file OMax.build.c.

t_symbol * OMax_build_dataname | ( | t_symbol * | name | ) |

Return Data Sequence name from FO name.

Append `_data` to the FO name

Definition at line 192 of file OMax.build.c.

void * OMax_build_new | ( | t_symbol * | s,
|  | long | argc,
|  | t_atom * | argv |
| ) |  |  |

Object instantiation.

Check first & second arguments of the Max5 object for a FO name and another Data Sequence name

Definition at line 102 of file OMax.build.c.

Here is the call graph for this function:

The documentation for this struct was generated from the following file:

- OMax.build.c